HDU - 2639

The title of this problem is familiar,isn't it?yeah,if you had took part in the "Rookie Cup" competition,you must have seem this title.If you haven't seen it before,it doesn't matter,I will give you a link: 

Here is the link:  http://acm.hdu.edu.cn/showproblem.php?pid=2602 

Today we are not desiring the maximum value of bones,but the K-th maximum value of the bones.NOTICE that,we considerate two ways that get the same value of bones are the same.That means,it will be a strictly decreasing sequence from the 1st maximum , 2nd maximum .. to the K-th maximum. 

If the total number of different values is less than K,just ouput 0.
Input
The first line contain a integer T , the number of cases. 
Followed by T cases , each case three lines , the first line contain two integer N , V, K(N <= 100 , V <= 1000 , K <= 30)representing the number of bones and the volume of his bag and the K we need. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone. 
Output
One integer per line representing the K-th maximum of the total value (this number will be less than 2  31). 
Sample Input
3
5 10 2
1 2 3 4 5
5 4 3 2 1
5 10 12
1 2 3 4 5
5 4 3 2 1
5 10 16
1 2 3 4 5
5 4 3 2 1
Sample Output
12
2
0

 思路:在原先的一维dp上加多维存取第K大,用dp[j][k]代表在剩余j容量下时的第k大获取价值

#include <iostream>
#include <cstring>
#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
using namespace std;
int v[105],w[105];
int dp[1005][35];   
int a[35],b[35];
int main(){
    int T;
    cin>>T;
    while(T--){
        memset(dp,0,sizeof(dp));
        memset(a,0,sizeof(a));
        memset(b,0,sizeof(b));
        int N,V,K;
        cin>>N>>V>>K;
        for(int i=1;i<=N;i++) cin>>v[i];
        for(int i=1;i<=N;i++) cin>>w[i];
        for(int i=1;i<=N;i++){
            for(int j=V;j>=w[i];j--){
                for(int k=1;k<=K;k++){
                    a[k]=dp[j][k];   //dp[j][k]代表在剩余j容量下时的第k大获取价值
                    b[k]=dp[j-w[i]][k]+v[i];
                }
                a[K+1]=b[K+1]=-1; // 这里需要注意一下。。当下面所述的在h<=K情况下,x>K了那么就填充y,因为b[y]可能为0,所以要设置-1..
                int h=1,x=1,y=1;
                while(h<=K&&(x<=K||y<=K)){
                    int t;
                    if(a[x]>b[y]){
                        dp[j][h]=a[x++];
                    }
                    else{
                        dp[j][h]=b[y++];
                    }
                    if(dp[j][h]!=dp[j][h-1])
                        h++;

                }
            }
        }
        cout<<dp[V][K]<<endl;
    }

    return 0;
}



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值